enum
{
	CONST0,
	CONST1,
	RANDOM,

	INC,
	DEC,

	ADD,
	SUB,
	MUL,
	DIV,

	EQ,
	NE,
	LT,
	GT,
	LE,
	GE,

	AND,
	OR,
	NOT,

	LABEL0,
	LABEL1,

	JMP,
	JT,
	JF,

	CALL,
	RET,

	DUP,
	SWAP,
	POP,

	LOAD,
	STORE,
	
	INSTRUCTIONS
};

typedef struct Instruction_t
{
	int op;
	struct Instruction_t *jmp;
} Instruction;

typedef struct
{
	char *code;
	int size;
	int fitness;
	int index;
	int sort;
} Program;

extern Instruction *code0;
extern Instruction *code1;

extern int *memory0;
extern int *memory1;

extern int *gmemory;
extern int *gsp;

extern int *blocks0;
extern int *blocks1;

void initCode();
int readInstruction(FILE *f);
void unpack(Program *p, Instruction *code);
void exec(Instruction *code, int size, int *memory);
int pop();
void writeInstruction(FILE *f, int op);
