#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "lithos.h"

/*
#include "code.h"
#include "pop.h"
#include "params.h"
#include "misc.h"
#include "stats.h"
*/
//#include "gnugo-3.6/engine/gnugo.h"


#define squares (boardSize * boardSize)

#define DISPUTED 3

static int boardSize;

char **board;

char **oldBoard;
char **mark;

static int score0, score1, captures0, captures1;
static int pass;
static int prisoners;

void eval_init(int boardsize){
	
	int i,j;
	
	if(board != NULL){
		for(i=0; i<boardSize; i++){
			if(board[i] != NULL){
				free(board[i]);
			}
		}
		free(board);
	}
	
	board=(char**)malloc(boardsize*(sizeof (char*)));
	for(i=0; i<boardsize; i++){
		board[i]=(char*)malloc(boardsize*(sizeof (char)));
		for(j=0; j<boardsize; j++){
			board[i][j]=0;
		}
	}
	
	
	if(oldBoard != NULL){
		for(i=0; i<boardSize; i++){
			if(oldBoard[i] != NULL){
				free(oldBoard[i]);
			}
		}
		free(oldBoard);
	}
	oldBoard=(char**)malloc(boardsize*(sizeof (char*)));
	for(i=0; i<boardsize; i++){
		oldBoard[i]=(char*)malloc(boardsize*(sizeof (char)));
		for(j=0; j<boardsize; j++){
			oldBoard[i][j]=0;
		}
	}
	
	if(mark != NULL){
		for(i=0; i<boardSize; i++){
			if(mark[i] != NULL){
				free(mark[i]);
			}
		}
		free(mark);
	}
	mark=(char**)malloc(boardsize*(sizeof (char*)));
	for(i=0; i<boardsize; i++){
		mark[i]=(char*)malloc(boardsize*(sizeof (char)));
		for(j=0; j<boardsize; j++){
			mark[i][j]=0;
		}
	}

	
	boardSize=boardsize;
	
	//printBoard();
	
}

void clearboard(){
	int i,j;
	for(i=0; i<boardSize; i++){
		for(j=0; j<boardSize; j++){
			board[i][j]=0;
		}
	}
	memset(memory0, 0, maxMemory * sizeof(int));
	memset(memory1, 0, maxMemory * sizeof(int));
	score0 = 0;
	score1 = 0;
	pass = 0;

}

static int liberty2(int i, int j)
{
	int color;
	if (mark[i][j])
		return 0;
	mark[i][j] = 1;
	color = board[i][j];
	if (i > 0)
	{
		int color1 = board[i - 1][j];
		if (!color1)
			return 1;
		if (color1 == color && liberty2(i - 1, j))
			return 1;
	}
	if (i < boardSize - 1)
	{
		int color1 = board[i + 1][j];
		if (!color1)
			return 1;
		if (color1 == color && liberty2(i + 1, j))
			return 1;
	}
	if (j > 0)
	{
		int color1 = board[i][j - 1];
		if (!color1)
			return 1;
		if (color1 == color && liberty2(i, j - 1))
			return 1;
	}
	if (j < boardSize - 1)
	{
		int color1 = board[i][j + 1];
		if (!color1)
			return 1;
		if (color1 == color && liberty2(i, j + 1))
			return 1;
	}
	return 0;
}

int liberty(int i, int j)
{
	if (!board[i][j])
		return 1;
		int a,b;
	for(a=0; a<boardSize; a++){
		for(b=0; b<boardSize; b++){
			mark[a][b]=0;
		}
	}
	return liberty2(i, j);
}

static void removeGroup(int i, int j)
{
	int color = board[i][j];
	board[i][j] = 0;
	prisoners++;
	if (i > 0 && board[i - 1][j] == color)
		removeGroup(i - 1, j);
	if (i < boardSize - 1 && board[i + 1][j] == color)
		removeGroup(i + 1, j);
	if (j > 0 && board[i][j - 1] == color)
		removeGroup(i, j - 1);
	if (j < boardSize - 1 && board[i][j + 1] == color)
		removeGroup(i, j + 1);
}

void capture2(int i, int j)
{
	if (!liberty(i, j))
		removeGroup(i, j);
}

void capture(int i, int j)
{
	prisoners = 0;
	if (i > 0)
		capture2(i - 1, j);
	if (i < boardSize - 1)
		capture2(i + 1, j);
	if (j > 0)
		capture2(i, j - 1);
	if (j < boardSize - 1)
		capture2(i, j + 1);
}




Move *getmove(Move *move, Instruction *code, int size, int *memory, int color)
{
	int i, j, k;
	if (color > 0)
	{
		for (i = 0, k=0; i < boardSize; i++){
			for (j = 0;j<boardSize; j++){
				memory[k] = board[i][j];
				k++;
			}
		}
		memory[squares] = score0;
		memory[squares + 1] = -score1;
	}
	else
	{
		for (i = 0, k=0; i < boardSize; i++){
			for (j = 0;j<boardSize; j++){
				memory[k] = -board[i][j];
				k++;
			}
		}
		memory[squares] = score1;
		memory[squares + 1] = -score0;
	}
	exec(code, size, memory);
	j = pop();
	i = pop();
	printf("#computer plays (%d,%d)\n", i, j);
	if (i < 0 || i >= boardSize ||
		j < 0 || j >= boardSize ||
		board[i][j])
	{

		move->pass = 1;
		return move;
	}
	board[i][j] = color;
	capture(i, j);
	if (!prisoners && !liberty(i, j))
	{
		board[i][j] = 0;

		move->pass = 1;
		return move;
	}
	
	move->i=i;
	move->j=j;
	move->pass=0;
	return move;
}

int move(Instruction *code, int size, int *memory, int color)
{
	int i, j, k=0;
	
	if (color > 0)
	{
		for (i = 0; i < boardSize; i++){
			for (j = 0;j<boardSize; j++){
				memory[k] = board[i][j];
				k++;
			}
		}
		memory[squares] = score0;
		memory[squares + 1] = -score1;
	}
	else
	{
		for (i = 0; i < boardSize; i++){
			for (j = 0;j<boardSize; j++){
				memory[k] = -board[i][j];
				k++;
			}
		}
		memory[squares] = score1;
		memory[squares + 1] = -score0;
	}
	exec(code, size, memory);
	j = pop();
	i = pop();
	//printf("computer plays (%d,%d)\n", i, j);
	if (i < 0 || i >= boardSize ||
		j < 0 || j >= boardSize ||
		board[i][j])
	{
		if (pass)
			return 0;
		pass = 1;
		return 1;
	}
	board[i][j] = color;
	capture(i, j);
	if (!prisoners && !liberty(i, j))
	{
		board[i][j] = 0;
		if (pass)
			return 0;
		pass = 1;
		return 1;
	}
	pass = 0;
	return 1;
}

void play_move(int i, int j, char color){
	int intcolor;
	if(color=='W'){
		intcolor = -1;
	}
	else{
		intcolor = 1;
	}
	board[i][j] = intcolor;
	capture(i, j);
	if (!prisoners && !liberty(i, j))
	{
		board[i][j] = 0;
		pass = 1;
		return;
	}
	pass = 0;
	return;
}

int illegal_move(int i, int j){
	//printf("(%d,%d)\n",i,j);
	return (i < 0 || i >= boardSize ||
			j < 0 || j >= boardSize ||
			board[i][j]);
}

static void play(int size0, int size1)
{
	int i,j;
	for(i=0; i<boardSize; i++){
		for(j=0; j<boardSize; j++){
			board[i][j]=0;
		}
	}
	memset(memory0, 0, maxMemory * sizeof(int));
	memset(memory1, 0, maxMemory * sizeof(int));
	score0 = 0;
	score1 = 0;
	pass = 0;
	for (i = 0; i < maxMoves; i++)
	{
		if (!move(code0, size0, memory0, 1))
			break;
		score0 += prisoners;
		if (!move(code1, size1, memory1, -1))
			break;
		score1 += prisoners;
	}
}




static int disputes(int i, int j, int color)
{
	int color1 = board[i][j];
	if (color1 == DISPUTED)
		return 1;
	if (color1 < 0 && color > 0 ||
		color1 > 0 && color < 0)
		return 1;
	return 0;
}

static int sign(int x)
{
	if (x < 0)
		return -1;
	if (x > 0)
		return 1;
	return 0;
}

static void markTerritory()
{
	int i, j;
	int changed;
	for (i = 0; i < boardSize; i++){
		for (j = 0; j < boardSize; j++){
			board[i][j] *= 2;
		}
	}
	
	do
	{
		changed = 0;
		for (i = 0; i < boardSize; i++)
			for (j = 0; j < boardSize; j++)
			{
				int color = board[i][j];
				if (color < -1 || color > 1)
					continue;

				if (i > 0 && disputes(i - 1, j, color) ||
					i < boardSize - 1 && disputes(i + 1, j, color) ||
					j > 0 && disputes(i, j - 1, color) ||
					j < boardSize - 1 && disputes(i, j + 1, color))
				{
					board[i][j] = DISPUTED;
					changed = 1;
					continue;
				}

				if (color)
					continue;

				if (i > 0)
				{
					int color1 = board[i - 1][j];
					if (color1)
					{
						board[i][j] = sign(color1);
						changed = 1;
						continue;
					}
				}
				if (i < boardSize - 1)
				{
					int color1 = board[i + 1][j];
					if (color1)
					{
						board[i][j] = sign(color1);
						changed = 1;
						continue;
					}
				}
				if (j > 0)
				{
					int color1 = board[i][j - 1];
					if (color1)
					{
						board[i][j] = sign(color1);
						changed = 1;
						continue;
					}
				}
				if (j < boardSize - 1)
				{
					int color1 = board[i][j + 1];
					if (color1)
					{
						board[i][j] = sign(color1);
						changed = 1;
						continue;
					}
				}
			}
	}
	while (changed);

	for (i = 0; i < boardSize; i++){
		for (i = 0; i < boardSize; i++){
			if (board[i][j] == DISPUTED)
				board[i][j] = 0;
			else
				board[i][j] = sign(board[i][j]);
		}
	}
}

void printBoard()
{
	int i, j;
	printf("B Caps: %d \tW Caps: %d\n", captures0, captures1);
	for (i = 0; i < boardSize; i++)
	{
		for (j = 0; j < boardSize; j++)
			switch (oldBoard[i][j])
			{
			case -1:
				putchar('O');
				break;
			case 0:
				putchar('.');
				break;
			case 1:
				putchar('*');
				break;
			default:
				printf("%d",oldBoard[i][j]);
				break;
			}
			
		putchar(' ');
		for (j = 0; j < boardSize; j++)
			switch (board[i][j])
			{
			case -1:
				putchar('O');
				break;
			case 0:
				putchar('.');
				break;
			case 1:
				putchar('*');
				break;
			default:
				printf("%d",oldBoard[i][j]);
				break;

			}
		putchar('\n');
	}
}

float scoring(){
		//	write game result to sgf
		FILE *game;
		char gamename[20]="game";
		char ext[5]=".sgf";
		char gamenameext[24]="";
		
		sprintf(gamename, "game-player-vs-0");
		//puts(gamenameext);
		strcat(gamenameext, gamename);
		//puts(gamenameext);
		strcat(gamenameext, ext);
		//puts(gamenameext);
		game = fopen(gamenameext, "w");

		fprintf(game, "(;GM[1]FF[4]CA[UTF-8]AP[lithos:2]ST[2]\nRU[Chinese]SZ[%d]KM[6.50]\nPW[White]PB[Black]\n", boardSize);
		int k, j;
		char white[1024]="AW";
		char black[1024]="AB";
		
		char stone[10];
		
		//printf("B Caps: %d \tW Caps: %d\n", captures0, captures1);
		for (k = 0; k < boardSize; k++)
		{
			
			//putchar(' ');
			for (j = 0; j < boardSize; j++)
				switch (board[k][j])
				{
				case -1:
					//putchar('O');
					sprintf(stone,"[%c%c]",('a'+k),('a'+j));
					strcat (white, stone);
					break;
				case 0:
					//putchar('.');
					break;
				case 1:
					//putchar('*');
					sprintf(stone,"[%c%c]",('a'+k),('a'+j));
					strcat (black, stone);
					break;
				}
			//putchar('\n');
		}
		if(strcmp(white, "AW")!=0){
			fprintf(game, white);
		}
		if(strcmp(black, "AB")!=0){
			fprintf(game, black);
		}
		
		fprintf(game, ")");
		fclose(game);
		
				
		// estimate game result
		FILE *fpipe;
		char command[256];
		sprintf(command, "./gnugo-mingw-36.exe --score estimate %s", gamenameext);
		char line[256];
		if ( !(fpipe = (FILE*)popen(command,"r")) )
		{  // If fpipe is NULL
			perror("Problems with pipe");
			exit(1);
		}
		char result [1024];
		while ( fgets( line, sizeof line, fpipe))
		{
			//printf("%s", line);
			sprintf(result,"%s", line);

		}
		
		pclose(fpipe);

		float scorewhite=0, scoreblack=0;
		//parse game result and put it in scorewhite and scoreblack


		char resultshort[20]="";
		if(result[0] == 'W'){
			
			sscanf(result, "White wins by %f points\n", &scorewhite);
						
		}
		else {
			
			sscanf(result, "Black wins by %f points\n", &scoreblack);
			
		}

		
		//add captures
		scorewhite+=score0;
		scoreblack+=score1;


		char gamenameextnew[24]="";
		strcat(gamenameextnew,gamename);
		if(result[0] == 'W'){
			sprintf(resultshort, "-W-%f",scorewhite);
		}
		else{
			sprintf(resultshort, "-B-%f",scoreblack);
		}
		strcat(gamenameextnew, resultshort);
		strcat(gamenameextnew, ext);
		
		sprintf(command, "mv %s %s", gamenameext, gamenameextnew);
		//puts(command);
		system(command);
		printf("Score White: %f, Black:%f\n", scorewhite, scoreblack);	
		
		return scorewhite-scoreblack;
}

void evaluate()
{
	int i, j, k;
	Program *p = &programs[evaluated];
	unpack(p, code0);
	p->fitness -= p->size;

	printf("Evaluating program %d\n", evaluated);
	for (i = 0; i < population; i++)
	{
		if (i == evaluated)
			continue;

		//printf("Evaluating program %d against program %d\n", evaluated, i);
		unpack(&programs[i], code1);
		play(p->size, programs[i].size);

		if (evaluated == 0 && i == 1){
			int a,b;
			for(a=0; a<boardSize; a++){
				for(b=0; b<boardSize; b++){
					oldBoard[a][b]= board[a][b];
				}
			}
			
		}

		
		markTerritory();
		
		captures0=score0;
		captures1= score1;

		for (j = 0; j < boardSize; j++){
			for (k = 0; k < boardSize; k++){
				switch (board[j][k])
				{
				case -1:
					score1++;
					break;
				case 1:
					score0++;
					break;
				}
			}
		}

		if (score0 > score1)
			p->fitness += maxSize + 1;
		else
			programs[i].fitness += maxSize + 1;

		if (evaluated == 0 && i == 1)
		{
			score = score0;
			printBoard();
		}
	}
}




int singlemove(int color)
{
	int i, j;

	puts("Your move(a,b):");
	scanf("(%d,%d)",&i, &j);
	puts("\n");

	
	if (i < 0 || i >= boardSize ||
		j < 0 || j >= boardSize ||
		board[i][j])
	{
		if (pass)
			return 0;
		pass = 1;
		return 1;
	}
	board[i][j] = color;
	capture(i, j);
	if (!prisoners && !liberty(i, j))
	{
		board[i][j] = 0;
		if (pass)
			return 0;
		pass = 1;
		return 1;
	}
	pass = 0;
	return 1;
}

void singleplay(int size0)
{
	int i, a, b;
	for(a=0; a<boardSize; a++){
		for(b=0; b<boardSize; b++){
			board[a][b]= 0;
		}
	}
	memset(memory0, 0, maxMemory * sizeof(int));
	score0 = 0;
	score1 = 0;
	pass = 0;
	for (i = 0; i < maxMoves; i++)
	{
		
		if (!move(code0, size0, memory0, 1))
			break;
		score0 += prisoners;
		for(a=0; a<boardSize; a++){
			for(b=0; b<boardSize; b++){
				oldBoard[a][b]= board[a][b];
			}
		}
		printBoard();
		if (!singlemove(-1))
			break;
		score1 += prisoners;
	}
}

int get_boardsize(){
	return boardSize;
}
