#include <string.h>
#include "lithos.h"

#define COMMAND_NUM 11

static char commands [COMMAND_NUM][256]={
	"protocol_version",
	"name",
	"version",
	"known_command",
	"list_commands",
	"quit",
	"boardsize",
	"clear_board",
	"komi",
	"play",
	"genmove"
};

void gtp(int size){

	setbuf(stdin, NULL);
	setbuf(stdout, NULL);
	//puts("#gtp parser started\n");
	char temp[1024];
	while(1){
		//puts("#waiting to read\n");
		fgets(temp, sizeof(temp),stdin);
		
		//printf("#line read: [%s]\n", temp);
		char *newline = strchr(temp, '\n'); /* search for newline character */
		if ( newline != NULL )
		{
			*newline = '\0'; /* overwrite trailing newline */
		}
		//printf("#line read: [%s]\n", temp);
		int len= strlen(temp);
		if (len==0){
			continue;
		}
		char temp2[1024];
		int len2= strlen(temp2);
		int i, j;
		int end=0;
		int command=0;
		
		for(i=j=0; i<len && j<len2 && !end; i++){
			if ((temp[i]> 32 && temp[i] <= 126) || temp[i]==10){
				command=1;
				temp2[j]=temp[i];
				j++;
			}
			else if(temp[i]=='#'){
				temp2[j]='\0';
				end=1;
			}
			else if(temp[i]==9){
				temp2[j]=' ';
				j++;
			}

		}
		//printf("#line read: [%s]\n", temp);
		if (!command){
			continue;
		}
		
		else if(strstr(temp, "protocol_version")==temp){
			printf("= 2\n\n");
		}
		else if(strstr(temp, "name")==temp){
			printf("= Lithos\n\n");
		}
		else if(strstr(temp, "version")==temp){
			printf("= 2\n\n");
		}
		else if(strncmp(temp,"known_command",13)==0){
			int retorno=0;
			int i;
			//printf("%s\n",temp);
			for(i=0; i<COMMAND_NUM && !retorno; i++){
				retorno=(strcmp(&temp[14], commands[i])==0);
				//printf("%s == %s ->%d\n",&temp[14], commands[i],retorno);
				if( retorno){
					printf("= true\n\n");
				}
			}
			if (!retorno){
				printf("= false\n\n");
			}
			
		}
		else if(strstr(temp, "list_commands")==temp){
			int i;
			printf("= ");
			for(i=0; i<COMMAND_NUM; i++){
				printf("%s\n",commands[i]);
			}
			puts("\n");
		}
		else if(strstr(temp, "quit")==temp){
			printf("= \n\n");
			exit(0);
		}
		else if(strncmp(temp,"boardsize",9)==0){
			int boardsize=0;
			if (sscanf(&temp[10], "%d", &boardsize)<1){
				printf("? boardsize not an integer\n\n");
			}
			else{
				if(boardsize<=0){
					printf("? unnaceptable size\n\n");
				}
				else{
					//set boardsize	
					eval_init(boardsize);
					printf("=\n\n");
				}	
			}
			
		}
		else if(strstr(temp, "clear_board")==temp){
			//clear board
			clearboard();
			printf("=\n\n");
			
		}
		else if(strncmp(temp,"komi",4)==0){
			int komi=0;
			if (sscanf(&temp[5], "%f", &komi)<1){
				printf("? boardsize not a float\n\n");
			}
			else{
				//set komi
				printf("=\n\n");
				}
		}
		else if(strncmp(temp,"play",4)==0){
			char color;
			char column;
			int line;
			if (strstr(temp, "pass")!=NULL || strstr(temp, "PASS")!=NULL){
				printf("=\n\n");
			}
			else if (sscanf(&temp[5], "%c %c%d", &color, &column, &line)<3){
				printf("? invalid color or coordinate\n\n");
				//printf("[%c][%c][%d]\n",color,column,line);
				
			}
			else{
				//check for illegal move
				
				int i= ((int)column)-((int)'A');
				line=get_boardsize()-line;
				
				if(illegal_move(i,line)){
					printf("? illegal move\n\n");
				}
				else{
					//play move
					play_move(i, line, color);
					printf("=\n\n");
				}
				
			}
		}
		
		else if(strncmp(temp,"genmove",7)==0){
			char color;
			if (sscanf(&temp[8], "%c", &color)<1){
				
				printf("? invalid color\n\n");
			}
			else{
				Move move;
				memset(&move,0,sizeof(Move));
				memset(memory0, 0, maxMemory * sizeof(int));

				//printf ("color: [%c]", color);
				switch (color){
					case 'W':
					case 'w':
						//generate white move
						//printf("(%d,%d), pass=%d\n",move.i,move.j, move.pass);
						getmove(&move, code0, size, memory0, -1);
						//printf("(%d,%d), pass=%d\n",move.i,move.j, move.pass);
						if (move.pass){
							printf("= PASS\n\n");
						}
						else{
							char column=((int)'A')+move.i;
							int line=get_boardsize()-move.j;
							printf("= %c%d\n\n", column, line);
						}
						break;
					case 'B':
					case 'b':
						//generate black move
						//printf("(%d,%d), pass=%d\n",move.i,move.j, move.pass);
						getmove(&move, code0, size, memory0, -1);
						//printf("(%d,%d), pass=%d\n",move.i,move.j, move.pass);
						if (move.pass){
							printf("= PASS\n\n");
						}
						else{
							char column=((int)'A')+move.i;
							int line=get_boardsize()-move.j;
							printf("= %c%d\n\n", column, line);
						}
						break;
					default:
						printf("? invalid color\n\n");
						break;
				}
			}
		}
		else{
			printf("? unknown_command\n\n");
		}
	}
}
