//#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include "lithos.h"


#include <string.h>
//#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <termios.h>
//#include <stropts.h>



int _kbhit() {
    static const int STDIN = 0;
    static int initialized = 0;

    if (! initialized) {
        // Use termios to turn off line buffering
        struct termios term;
        tcgetattr(STDIN, &term);
        term.c_lflag &= ~ICANON;
        tcsetattr(STDIN, TCSANOW, &term);
        setbuf(stdin, NULL);
        initialized = 1;
    }

    /*
    int bytesWaiting;
    ioctl(STDIN, FIONREAD, &bytesWaiting);
    return bytesWaiting;
    */
    struct timeval timeout;
    fd_set rdset;

    FD_ZERO(&rdset);
    FD_SET(STDIN, &rdset);
    timeout.tv_sec  = 0;
    timeout.tv_usec = 0;

    return select(STDIN + 1, &rdset, NULL, NULL, &timeout);  
    
}

static void test()
{
	printf("Testing\n");
	unpack(&programs[0], code0);
	memset(memory0, 0, maxMemory * sizeof(int));
	exec(code0, programs[0].size, memory0);
	while (gsp != gmemory)
		printf("%d\n", pop());
}

static void save()
{
	FILE *f = fopen("data", "w");
	if (!f)
	{
		printf("Unable to create data file");
		exit(EXIT_FAILURE);
	}
	writeParameters(f);
	fputc('\n', f);
	writeStatistics(f);
	writePopulation(f);
	fclose(f);
}

static void autosave()
{
	if (!autosaveFrequency)
		return;
	if (generations % autosaveFrequency)
		return;
	printf("Autosaving\n");
	save();
}

static void run()
{
LOOP:
	printf("Starting\n");
	while (!_kbhit())
	{
		if (evaluated >= population)
		{
			autosave();
			writeLog();
			nextGeneration();
		}
		evaluate();
		evaluated++;
	}
	if (getchar() == ' ')
	{
		printf("Stopped\n");
		if (getchar() == ' ')
			goto LOOP;
	}
}


int /*__cdecl*/ main(int argc, char **argv)
{
	FILE *f;

	if (argc == 2 && strcmp(argv[1], "-play")==0){
		
		initRandom();
		f= fopen("data", "r");
		if (f)
		{
			readParameters(f);
			initPopulation();
			readStatistics(f);
			readPopulation(f);
			fclose(f);
		}
		else{
			puts("Please create population first");
			exit(-1);
		}
		initCode();
		eval_init(9);
		
		//playing the best
		Program *p = &programs[0];
		unpack(p, code0);		
		singleplay(p->size);
		float finalscore= scoring();
		printf("Score: %f", finalscore);

	
		
	}
	
	if (argc == 2 && strcmp(argv[1], "-gtp")==0){
		//puts("#GTP starting\n");
		initRandom();
		
		f= fopen("data", "r");
		if (f)
		{
			readParameters(f);
			//puts("#parameters read\n");
			initPopulation();
			//puts("#population inited\n");
			readStatistics(f);
			//puts("#statistics read\n");
			readPopulation(f);
			//puts("#population read\n");
			fclose(f);
		}
		else{
			puts("Please create population first");
			exit(-1);
		}
		initCode();
		//puts("#code inited\n");
		eval_init(9);
		//puts("#eval inited\n");
		
		Program *p = &programs[0];
		unpack(p, code0);
		//puts("#program unpacked\n");		
		
		gtp();
	}
	else if (argc > 2 ||
		argc == 2 && strcmp(argv[1], "-t"))
	{
		printf("Lithos version 1.0\n"
			"Usage: lithos [-t]\n");
		return 1;
	}
	else{

		initRandom();
		f= fopen("data", "r");
		if (f)
		{
			readParameters(f);
			initPopulation();
			readStatistics(f);
			readPopulation(f);
			fclose(f);
		}
		else if (argc == 2 && strcmp(argv[1], "-test")==0)
		{
			test();
			return 0;
		}
	
		else
		{
			f = fopen("params", "r");
			if (f)
			{
				readParameters(f);
				fclose(f);
			}
			initPopulation();
			printf("Generation 0\n");
			if (logFrequency)
			{
				f = fopen("log", "w");
				if (!f)
				{
					printf("Unable to create log file");
					return 1;
				}
				fprintf(f, "Generation\tComplexity\tDiversity\tScore\n");
				fclose(f);
			}
		}
		initCode();
		eval_init(9);
	
	
		startTime = time(0);
		run();
	
		printf("Saving\n");
		save();
		printf("Done\n");
		return 0;
	}
}
