#include <stdlib.h>
#include "lithos.h"

int score;

void *alloc(int bytes)
{
	void *p = malloc(bytes);
	if (!p)
	{
		printf("Out of memory\n");
		exit(EXIT_FAILURE);
	}
	return p;
}

void writeLog()
{
	FILE *f;
	int i;
	char species[INSTRUCTIONS][INSTRUCTIONS];
	int diversity = 0;

	if (logFrequency == 0)
		return;
	if (generations % logFrequency)
		return;

	memset(species, 0, sizeof species);
	for (i = 0; i < population; i++)
	{
		Program *p = &programs[i];
		int first;
		int last;
		if (!p->size)
			continue;
		first = p->code[0];
		last = p->code[p->size - 1];
		if (!species[first][last])
		{
			species[first][last] = 1;
			diversity++;
		}
	}

	f = fopen("log", "a");
	if (!f)
	{
		printf("Unable to open log file\n");
		exit(EXIT_FAILURE);
	}
	fprintf(f, "%d\t%d\t%d\t%d\n",
		generations, programs[0].size, diversity, score);
	fclose(f);
}
